{
 	File:		Translation.p
 
 	Copyright:	 1984-1994 by Apple Computer, Inc.
 				All rights reserved.
 
 	Version:	Built by:			anonymous
 				From:				Translation.i, revision 8, dated 5/31/94
 				With Interfacer:	1.1d4e2
 
 	Bugs:		Report bugs to Radar component System Interfaces, Latest
 				List the version information from above in Problem Description.
 
}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT Translation;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __TRANSLATION__}
{$SETC __TRANSLATION__ := 1}

{$I+}
{$SETC TranslationIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED REZ }

{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}
{	ConditionalMacros.p											}
{	MixedMode.p													}
{		Traps.p													}

{$IFC UNDEFINED __FILES__}
{$I Files.p}
{$ENDC}
{	OSUtils.p													}
{	SegLoad.p													}

{$IFC UNDEFINED __COMPONENTS__}
{$I Components.p}
{$ENDC}

{$IFC UNDEFINED __TRANSLATIONEXTENSIONS__}
{$I TranslationExtensions.p}
{$ENDC}
{	Memory.p													}
{	Quickdraw.p													}
{		QuickdrawText.p											}
{			IntlResources.p										}
{	Components.p												}
{$SETC gestaltTranslationPPCAvail := 2}
{$SETC gestaltTranslationGetPathAPIAvail := 3}

TYPE
	FileTranslationSpec = ARRAY [0..11] OF LONGINT;

	DocOpenMethod = INTEGER;


CONST
	domCannot					= 0;
	domNative					= 1;
	domTranslateFirst			= 2;
	domWildcard					= 3;


TYPE
	TypesBlock = ARRAY [0..63] OF OSType;

	TypesBlockPtr = ^OSType;

{$SETC TranslationScrapProgressDialogID := -16555}
	{$ALIGN MAC68K}
	TranslationSpec = PACKED RECORD
		componentSignature:		OSType;
		translationSystemInfo:	Ptr;
		src:					FileTypeSpec;
		dst:					FileTypeSpec;
	END;
	{$ALIGN RESET}
	TranslationSpecArrayPtr = ^TranslationSpec;


FUNCTION GetFileTypesThatAppCanNativelyOpen(appVRefNumHint: INTEGER; appSignature: OSType; VAR nativeTypes: FileType): OSErr;
	{$IFC USES68KINLINES}
	INLINE $701C, $ABFC;
	{$ENDC}
FUNCTION ExtendFileTypeList(originalTypeList: FileType; numberOriginalTypes: INTEGER; VAR extendedTypeList: FileType; VAR numberExtendedTypes: INTEGER): OSErr;
	{$IFC USES68KINLINES}
	INLINE $7009, $ABFC;
	{$ENDC}
FUNCTION CanDocBeOpened(targetDocument: FSSpec; appVRefNumHint: INTEGER; appSignature: OSType; nativeTypes: FileType; onlyNative: BOOLEAN; VAR howToOpen: DocOpenMethod; VAR howToTranslate: FileTranslationSpec): OSErr;
	{$IFC USES68KINLINES}
	INLINE $701E, $ABFC;
	{$ENDC}
FUNCTION GetFileTranslationPaths(VAR srcDocument: FSSpec; dstDocType: FileType; maxResultCount: INTEGER; resultBuffer: TranslationSpecArrayPtr): INTEGER;
	{$IFC USES68KINLINES}
	INLINE $7038, $ABFC;
	{$ENDC}
FUNCTION GetPathFromTranslationDialog(theDocument: FSSpec; theApplication: FSSpec; typeList: TypesBlockPtr; VAR howToOpen: DocOpenMethod; VAR howToTranslate: FileTranslationSpec): OSErr;
	{$IFC USES68KINLINES}
	INLINE $7037, $ABFC;
	{$ENDC}
FUNCTION TranslateFile(sourceDocument: FSSpec; destinationDocument: FSSpec; howToTranslate: FileTranslationSpec): OSErr;
	{$IFC USES68KINLINES}
	INLINE $700C, $ABFC;
	{$ENDC}
FUNCTION GetDocumentKindString(docVRefNum: INTEGER; docType: OSType; docCreator: OSType; kindString: Str63): OSErr;
	{$IFC USES68KINLINES}
	INLINE $7016, $ABFC;
	{$ENDC}
FUNCTION GetTranslationExtensionName(translationMethod: TranslationSpec; extensionName: Str31): OSErr;
	{$IFC USES68KINLINES}
	INLINE $7036, $ABFC;
	{$ENDC}
TYPE
	GetScrapDataProcPtr = ProcPtr;  { FUNCTION (requestedFormat: ScrapType; dataH: Handle; srcDataGetterRefCon: UNIV Ptr): OSErr; }


FUNCTION TranslateScrap(sourceDataGetter: GetScrapDataProcPtr; sourceDataGetterRefCon: UNIV Ptr; destinationFormat: ScrapType; destinationData: Handle; progressDialogID: INTEGER): OSErr;
	{$IFC USES68KINLINES}
	INLINE $700E, $ABFC;
	{$ENDC}
{$ENDC}

{$SETC UsingIncludes := TranslationIncludes}

{$ENDC} {__TRANSLATION__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
